"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createFlowieContainer() {
    return {
        functionsContainer: Object.freeze({}),
        register(flowItemName, flowFunction) {
            return registerFlowieItem({}, flowItemName, flowFunction);
        }
    };
}
exports.default = createFlowieContainer;
function registerFlowieItem(previousFunctionsContainer, flowItemName, flowFunction) {
    const newFunctionsContainer = { ...previousFunctionsContainer, [flowItemName]: flowFunction };
    const newFunctionsContainerProxy = new Proxy(newFunctionsContainer, { get: getItemFromContainer });
    return {
        functionsContainer: Object.freeze(newFunctionsContainerProxy),
        register: registerFlowieItem.bind(null, newFunctionsContainer)
    };
}
function getItemFromContainer(target, flowItemName) {
    return target[flowItemName];
}
//# sourceMappingURL=createFlowieContainer.js.map