"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const flowieResult_1 = require("./flowieResult");
const buildFlowieFromContainer_1 = require("./buildFlowieFromContainer");
const validateFlowieContainer_1 = require("./validateFlowieContainer");
async function executeFlowieContainer(flowieContainer, flow, initialValue) {
    const error = validateFlowieContainer_1.default(flow, flowieContainer);
    if (error) {
        return flowieResult_1.default.fail(error);
    }
    const flowieFlow = buildFlowieFromContainer_1.default(flowieContainer, flow);
    return flowieFlow.executeFlow(initialValue);
}
exports.default = executeFlowieContainer;
//# sourceMappingURL=executeFlowieContainer.js.map